#include "SET_COMPILE_HMG_UNICODE.ch"
#include "HMG_UNICODE.h"

#include <windows.h>
//#include <iostream>
#include <string>

#include "hbapi.h"
#include "hbapiitm.h"

using namespace std;

typedef struct _SCALE
{
  INT    masterAddress;
  LPWSTR ipAddress;
  INT    txPort;
  INT    rxPort;
  LPWSTR model;
  LPWSTR display;
  LPWSTR section;
  INT    group;
  LPWSTR logsPath;
} SCALE;

typedef struct _ITEM
{
  INT    code;
  INT    directKey;
  DOUBLE price;
  LPWSTR name;
  INT    type;
  INT    section;
  LPWSTR expiryDate;
  INT    alterPrice;
  INT    number;
  INT    priceFactor;
  LPWSTR textG;
} ITEM;


        //Dibalscop_ItemsSend(aScale, aItem, lShowWindow, nCloseTime)
HB_FUNC ( DIBALSCOP_ITEMSSEND )
{
  string WINAPI (*pItemsSend)(SCALE * myScales, INT numScales, ITEM * myItems, INT numItems, INT showWindow, INT closeTime);

  HMODULE  hLib      = LoadLibraryA("Dibalscop.dll");
  PHB_ITEM pArray    = hb_itemNew(NULL);
  PHB_ITEM pSubArray = hb_itemNew(NULL);
  HB_SIZE  nScales;
  HB_SIZE  nItems;
  UINT     n;

  if (hLib)
  {
    pItemsSend = (string WINAPI (*)(SCALE *, INT, ITEM *, INT, INT, INT)) GetProcAddress(hLib, "ItemsSend");

    if (pItemsSend)
    {
      pArray  = hb_param(1, HB_IT_ARRAY);
      nScales = hb_arrayLen(pArray);

      SCALE sc[nScales];

      for (n = 0; n < nScales; ++n)
      {
        hb_arrayGet(pArray, n+1, pSubArray);
        
        sc[n].masterAddress = (INT)    hb_arrayGetNI   (pSubArray, 1);
        sc[n].ipAddress     = (LPWSTR) HMG_arrayGetCPtr(pSubArray, 2);
        sc[n].txPort        = (INT)    hb_arrayGetNI   (pSubArray, 3);
        sc[n].rxPort        = (INT)    hb_arrayGetNI   (pSubArray, 4);
        sc[n].model         = (LPWSTR) HMG_arrayGetCPtr(pSubArray, 5);
        sc[n].display       = (LPWSTR) HMG_arrayGetCPtr(pSubArray, 6);
        sc[n].section       = (LPWSTR) HMG_arrayGetCPtr(pSubArray, 7);
        sc[n].group         = (INT)    hb_arrayGetNI   (pSubArray, 8);
        sc[n].logsPath      = (LPWSTR) HMG_arrayGetCPtr(pSubArray, 9);
      }

      pArray = hb_param(2, HB_IT_ARRAY);
      nItems = hb_arrayLen(pArray);

      ITEM it[nItems];

      for (n = 0; n < nItems; ++n)
      {
        hb_arrayGet(pArray, n+1, pSubArray);
        
        it[n].code        = (INT)    hb_arrayGetNI   (pSubArray,  1);
        it[n].directKey   = (INT)    hb_arrayGetNI   (pSubArray,  2);
        it[n].price       = (DOUBLE) hb_arrayGetND   (pSubArray,  3);
        it[n].name        = (LPWSTR) HMG_arrayGetCPtr(pSubArray,  4);
        it[n].type        = (INT)    hb_arrayGetNI   (pSubArray,  5);
        it[n].section     = (INT)    hb_arrayGetNI   (pSubArray,  6);
        it[n].expiryDate  = (LPWSTR) HMG_arrayGetCPtr(pSubArray,  7);
        it[n].alterPrice  = (INT)    hb_arrayGetNI   (pSubArray,  8);
        it[n].number      = (INT)    hb_arrayGetNI   (pSubArray,  9);
        it[n].priceFactor = (INT)    hb_arrayGetNI   (pSubArray, 10);
        it[n].textG       = (LPWSTR) HMG_arrayGetCPtr(pSubArray, 11);
      }

      hb_retc((LPCSTR) pItemsSend(sc, nScales, it, nItems, hb_parl(3), hb_parni(4)).c_str());
    }
    else
    {
      hb_retc("No ItemsSend function");
    }

    FreeLibrary(hLib);
  }
  else
  {
    hb_retc("No Dibalscop.dll");
  }
}
